<?php
/*
Plugin Name: Firefox Counter
Plugin URI: http://wordpress.org/#
Description: This allows you to put the <code>firefox_count()</code> function in your template to get the latest download count for <a href="http://www.mozilla.org/products/firefox/">everyone's favorite browser</a>. Call like <code>firefox_count('thunderbird')</code> to get the count for Thunderbird.
Author: Matt Mullenweg
Version: 0.2
Author URI: http://photomatt.net/
*/ 

function firefox_count( $product = 'firefox' ) {
	$rss = '';
	$count = array();
	if ( ( $c = get_option('mm_' . $product . '_counter') ) && $c['date'] - gmdate('U') > 1400 ) : //&&  )  :
		echo $c['count'];
		return;
	endif;

	$url = 'http://www.spreadfirefox.com/download_counter.php?ff=1';
	if ( 'thunderbird' == $product )
		$url = 'http://www.spreadfirefox.com/download_counter.php?tb=1';

	$fp = @fopen( $url, 'r' );

	while( $remote_read = fread($fp, 4096) )
		$rss .= $remote_read;
	
	$count['count'] = preg_replace('|.*<description>(.*?)</description>.*|is', '$1', $rss);
	$count['date'] = strtotime( preg_replace('|.*<pubDate>(.*?)</pubDate>.*|is', '$1', $rss) );
	echo $count['count'];
	update_option( 'mm_' . $product . '_counter', $count );
	return;
}

?>